diff -ru hurd-0.0/libdiskfs/opts-version.c hurd-0.1/libdiskfs/opts-version.c
--- hurd-0.0/libdiskfs/opts-version.c	Mon Jul 29 12:33:28 1996
+++ hurd-0.1/libdiskfs/opts-version.c	Thu Sep  5 18:39:09 1996
@@ -21,6 +21,7 @@
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
 
 #include "priv.h"
+#include <version.h>
 
 static void
 _print_version (FILE *stream, struct argp_state *state)
@@ -28,12 +29,17 @@
   if (argp_program_version)
     /* If this is non-zero, then the program's probably defined it, so let
        that take precedence over the default.  */
-    fprintf (stream, "%s\n", argp_program_version);
+    fputs (argp_program_version, stream);
   else
-    /* Construct a version using the standard diskfs variables.  */
-    fprintf (stream, "%s %d.%d (GNU %s)\n",
-	     diskfs_server_name, diskfs_major_version, diskfs_minor_version,
-	     HURD_RELEASE);
+    {
+      fprintf (stream, "%s %s ", diskfs_server_name, diskfs_server_version);
+      if (diskfs_extra_version[0])
+	fprintf (stream, "(%s) ", diskfs_extra_version);
+    }
+  /* And because diskfs is big and huge, put our information out too. */
+  fputs (STANDARD_HURD_VERSION (libdiskfs), stream);
+  
+  putc ('\n', stream);
 }
 
 void (*argp_program_version_hook) (FILE *stream, struct argp_state *state)
diff -ru hurd-0.0/libdiskfs/readonly.c hurd-0.1/libdiskfs/readonly.c
--- hurd-0.0/libdiskfs/readonly.c	Mon Jun 24 17:04:31 1996
+++ hurd-0.1/libdiskfs/readonly.c	Thu Aug  8 18:17:55 1996
@@ -21,6 +21,7 @@
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
 
 #include <fcntl.h>
+#include <error.h>
 
 #include "priv.h"
 
@@ -29,13 +30,23 @@
 int
 diskfs_check_readonly ()
 {
+  error_t err;
+  
   if (diskfs_readonly)
     return 1;
   else
     {
       if (!_diskfs_diskdirty)
 	{
-	  diskfs_set_hypermetadata (1, 0);
+	  err = diskfs_set_hypermetadata (1, 0);
+	  if (err)
+	    {
+	      error (0, 0, 
+		     "%s: MEDIA NOT WRITABLE; switching to READ-ONLY",
+		     diskfs_device_arg);
+	      diskfs_readonly = 1;
+	      return 1;
+	    }
 	  _diskfs_diskdirty = 1;
 	}
       return 0;
Only in hurd-0.1: libhurdbugaddr
diff -ru hurd-0.0/libnetfs/ChangeLog hurd-0.1/libnetfs/ChangeLog
--- hurd-0.0/libnetfs/ChangeLog	Mon Jul 29 12:33:54 1996
+++ hurd-0.1/libnetfs/ChangeLog	Fri Aug 16 19:20:36 1996
@@ -1,3 +1,8 @@
+Fri Aug 16 19:20:22 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* priv.h (end_using_protid_port): Only call ports_port_deref if
+	CRED is set.
+
 Fri Jul 26 14:34:11 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* file-exec.c (netfs_S_file_exec): Unlock NP before we attempt to
diff -ru hurd-0.0/libnetfs/priv.h hurd-0.1/libnetfs/priv.h
--- hurd-0.0/libnetfs/priv.h	Mon Mar  4 13:54:23 1996
+++ hurd-0.1/libnetfs/priv.h	Fri Aug 16 19:20:10 1996
@@ -31,5 +31,6 @@
 extern inline void
 end_using_protid_port (struct protid *cred)
 {
-  ports_port_deref (cred);
+  if (cred)
+    ports_port_deref (cred);
 }
diff -ru hurd-0.0/libpager/ChangeLog hurd-0.1/libpager/ChangeLog
--- hurd-0.0/libpager/ChangeLog	Wed Jul 17 18:54:52 1996
+++ hurd-0.1/libpager/ChangeLog	Tue Aug 13 10:51:54 1996
@@ -1,3 +1,11 @@
+Tue Aug 13 10:47:47 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* object-terminate.c (_pager_free_structure): Don't bother calling
+	mach_port_deallocate if the cells are already null; set the cells
+	to null after the deallocation is done.
+	(_pager_seqnos_memory_object_terminate): Destroy the rights passed
+	in for control and name.
+
 Thu May  9 11:10:11 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* pager-create.c: Get rid of link warning.
diff -ru hurd-0.0/libpager/object-terminate.c hurd-0.1/libpager/object-terminate.c
--- hurd-0.0/libpager/object-terminate.c	Tue Mar 26 16:17:04 1996
+++ hurd-0.1/libpager/object-terminate.c	Tue Aug 13 10:49:47 1996
@@ -53,6 +53,12 @@
       condition_wait (&p->wakeup, &p->interlock);
     }
 
+  /* Destry the ports we received; mark that in P so that it doesn't bother
+     doing it again. */
+  mach_port_destroy (mach_task_self (), control);
+  mach_port_destroy (mach_task_self (), name);
+  p->memobjcntl = p->memobjname = MACH_PORT_NULL;
+
   _pager_free_structure (p);
 
 #ifdef KERNEL_INIT_RACE
@@ -104,8 +110,16 @@
   if (wakeup)
     condition_broadcast (&p->wakeup);
 
-  mach_port_deallocate (mach_task_self (), p->memobjcntl);
-  mach_port_deallocate (mach_task_self (), p->memobjname);
+  if (p->memobjcntl != MACH_PORT_NULL)
+    {
+      mach_port_deallocate (mach_task_self (), p->memobjcntl);
+      p->memobjcntl = MACH_PORT_NULL;
+    }
+  if (p->memobjname != MACH_PORT_NULL)
+    {
+      mach_port_deallocate (mach_task_self (), p->memobjname);
+      p->memobjname = MACH_PORT_NULL;
+    }
 
   /* Free the pagemap */
   if (p->pagemapsize)
diff -ru hurd-0.0/libports/ChangeLog hurd-0.1/libports/ChangeLog
--- hurd-0.0/libports/ChangeLog	Thu Jul 18 23:42:25 1996
+++ hurd-0.1/libports/ChangeLog	Wed Aug  7 15:29:09 1996
@@ -1,3 +1,8 @@
+Wed Aug  7 15:28:48 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ports.h (_ports_create_port_internal,
+	ports_create_port_noinstall): New declarations.
+
 Thu Jul 18 22:59:14 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* Makefile (SRCS): Add create-port-noinstall.c and create-internal.c.
diff -ru hurd-0.0/libports/ports.h hurd-0.1/libports/ports.h
--- hurd-0.0/libports/ports.h	Mon May  6 16:34:34 1996
+++ hurd-0.1/libports/ports.h	Wed Aug  7 15:28:35 1996
@@ -162,6 +162,18 @@
 			   struct port_bucket *bucket,
 			   size_t size,
 			   void *result);
+
+/* Just like ports_create_port, except don't actually put the port
+   into the portset underlying BUCKET.  This is intended to be used
+   for cases where the port right must be given out before the port is
+   fully initialized; with this call you are guaranteed that no RPC
+   service will occur on the port until you have finished initializing
+   it and installed it into the portset yourself. */
+error_t
+ports_create_port_noinstall (struct port_class *class,
+			     struct port_bucket *bucket,
+			     size_t size,
+			     void *result);
    
 /* For an existing RECEIVE right, create and return in RESULT a new port
    structure; BUCKET, SIZE, and CLASS args are as for ports_create_port. */
@@ -376,5 +388,7 @@
 #define _PORTS_BLOCKED		PORTS_BLOCKED
 #define _PORTS_INHIBIT_WAIT	PORTS_INHIBIT_WAIT
 void _ports_complete_deallocate (struct port_info *);
+error_t _ports_create_port_internal (struct port_class *, struct port_bucket *,
+				     size_t, void *, int);
 
 #endif
diff -ru hurd-0.0/libshouldbeinlibc/ChangeLog hurd-0.1/libshouldbeinlibc/ChangeLog
--- hurd-0.0/libshouldbeinlibc/ChangeLog	Wed Jul 31 15:24:32 1996
+++ hurd-0.1/libshouldbeinlibc/ChangeLog	Tue Sep  3 10:21:03 1996
@@ -1,3 +1,28 @@
+Fri Aug 30 20:44:44 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp-help.c (argp_help): Print documentation only according to
+	the ARGP_HELP_*_DOC bits in FLAGS.
+	Possibly print bug report address if ARGP_HELP_BUG_ADDR is set.
+	Replace FIRST by ANYTHING (sense inverted).
+	* argp.h (ARGP_HELP_PRE_DOC, ARGP_HELP_POST_DOC, ARGP_HELP_DOC,
+	ARGP_HELP_BUG_ADDR): New macros.
+	(ARGP_HELP_STD_HELP): Include ARGP_HELP_DOC & ARGP_HELP_BUG_ADDR.
+	(argp_program_bug_address): New declaration.
+	(ARGP_HELP_EXIT_ERR, ARGP_HELP_EXIT_OK): Values changed.
+	* Makefile (SRCS): Add argp-ba.c.
+
+Tue Aug 20 17:12:42 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp-help.c (argp_doc): Add FIRST_ONLY argument.
+	Don't output a blank line for empty post-docs.
+	(argp_help): Use it.  Move first call to argp_doc after newline.
+
+Mon Aug 19 14:45:30 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp-help.c (argp_help): Add note about --usage to `Try...' msg.
+	Supply new args to argp_doc, and additional call before arg help.
+	(argp_doc): Add the POST and PRE_BLANK arguments, & return val.
+
 Wed Jul 31 15:24:09 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
 
 	* wire.c (_start): No longer declared as weak, now that everything
diff -ru hurd-0.0/libshouldbeinlibc/Makefile hurd-0.1/libshouldbeinlibc/Makefile
--- hurd-0.0/libshouldbeinlibc/Makefile	Wed Jun 19 14:21:46 1996
+++ hurd-0.1/libshouldbeinlibc/Makefile	Tue Sep  3 10:21:03 1996
@@ -20,7 +20,7 @@
 makemode := library
 
 libname = libshouldbeinlibc
-SRCS = argp-parse.c argp-help.c argp-pv.c argp-pvh.c  \
+SRCS = argp-parse.c argp-help.c argp-pv.c argp-pvh.c argp-ba.c \
 	termsize.c idvec.c idvec-auth.c timefmt.c exec-reauth.c \
 	canon-host.c maptime.c shared-dom.c localhost.c wire.c portinfo.c \
 	xportinfo.c portxlate.c lcm.c cacheq.c fsysops.c
Only in hurd-0.1/libshouldbeinlibc: argp-ba.c
diff -ru hurd-0.0/libshouldbeinlibc/argp-help.c hurd-0.1/libshouldbeinlibc/argp-help.c
--- hurd-0.0/libshouldbeinlibc/argp-help.c	Mon Jul 29 12:34:28 1996
+++ hurd-0.1/libshouldbeinlibc/argp-help.c	Tue Sep  3 10:21:04 1996
@@ -709,23 +709,48 @@
       argp_args_usage (*children++, stream);
 }
 
-/* Print the documentation for ARGP to STREAM.  Each separate bit of
-   documentation is preceded by a blank line.  */
-static void
-argp_doc (const struct argp *argp, FILE *stream)
+/* Print the documentation for ARGP to STREAM; if POST is false, then
+   everything preceeding a `\v' character in the documentation strings (or
+   the whole string, for those with none) is printed, otherwise, everything
+   following the `\v' character (nothing for strings without).  Each separate
+   bit of documentation is separated a blank line, and if PRE_BLANK is true,
+   then the first is as well.  If FIRST_ONLY is true, only the first
+   occurance is output.  Returns true if anything was output.  */
+static int
+argp_doc (const struct argp *argp, int post, int pre_blank, int first_only,
+	  FILE *stream)
 {
   const struct argp **children = argp->children;
   const char *doc = argp->doc;
+  int anything = 0;
+
   if (doc)
     {
-      putc ('\n', stream);
-      fputs (doc, stream);
+      char *vt = index (doc, '\v');
+
+      if (pre_blank && (vt || !post))
+	putc ('\n', stream);
+
+      if (vt)
+	if (post)
+	  fputs (vt + 1, stream);
+	else
+	  fwrite (doc, 1, vt - doc, stream);
+      else
+	if (! post)
+	  fputs (doc, stream);
       if (line_wrap_point (stream) > line_wrap_lmargin (stream))
 	putc ('\n', stream);
+
+      anything = 1;
     }
   if (children)
-    while (*children)
-      argp_doc (*children++, stream);
+    while (*children && !(first_only && anything))
+      anything |=
+	argp_doc (*children++, post, anything || pre_blank, first_only,
+		  stream);
+
+  return anything;
 }
 
 /* Output a usage message for ARGP to STREAM.  FLAGS are from the set
@@ -733,7 +758,7 @@
 void argp_help (const struct argp *argp, FILE *stream,
 		unsigned flags, char *name)
 {
-  int first = 1;
+  int anything = 0;		/* Whether we've output anything.  */
   struct hol *hol = 0;
 
   if (! stream)
@@ -780,13 +805,18 @@
       line_wrap_set_lmargin (stream, old_lm);
 
       putc ('\n', stream);
-      first = 0;
+      anything = 1;
     }
 
+  if (flags & ARGP_HELP_PRE_DOC)
+    anything |= argp_doc (argp, 0, 0, 1, stream);
+
   if (flags & ARGP_HELP_SEE)
     {
-      fprintf (stream, "Try `%s --help' for more information.\n", name);
-      first = 0;
+      fprintf (stream,
+	       "Try `%s --help' or `%s --usage' for more information.\n",
+	       name, name);
+      anything = 1;
     }
 
   if (flags & ARGP_HELP_LONG)
@@ -795,14 +825,23 @@
       /* Print info about all the options.  */
       if (hol->num_entries > 0)
 	{
-	  if (! first)
+	  if (anything)
 	    putc ('\n', stream);
 	  hol_help (hol, stream);
-	  first = 0;
+	  anything = 1;
 	}
+    }
 
-      /* Finally, print any documentation strings at the end.  */
-      argp_doc (argp, stream);
+  if (flags & ARGP_HELP_POST_DOC)
+    /* Print any documentation strings at the end.  */
+    anything |= argp_doc (argp, 1, anything, 0, stream);
+
+  if ((flags & ARGP_HELP_BUG_ADDR) && argp_program_bug_address)
+    {
+      if (anything)
+	putc ('\n', stream);
+      fprintf (stream, "Report bugs to %s.\n", argp_program_bug_address);
+      anything = 1;
     }
 
   if (hol)
diff -ru hurd-0.0/libshouldbeinlibc/argp.h hurd-0.1/libshouldbeinlibc/argp.h
--- hurd-0.0/libshouldbeinlibc/argp.h	Sat Jul  6 17:12:56 1996
+++ hurd-0.1/libshouldbeinlibc/argp.h	Tue Sep  3 10:21:04 1996
@@ -258,6 +258,8 @@
 error_t argp_parse (const struct argp *argp,
 		    int argc, char **argv, unsigned flags,
 		    int *arg_index, void *input);
+
+/* Global variables.  */
 
 /* If defined or set by the user program to a non-zero value, then a default
    option --version is added (unless the ARGP_NO_HELP flag is used), which
@@ -272,16 +274,27 @@
    used).  This variable takes precedent over ARGP_PROGRAM_VERSION.  */
 extern void (*argp_program_version_hook) (FILE *stream,
 					  struct argp_state *state);
+
+/* If defined or set by the user program, it should point to string that is
+   the bug-reporting address for the program.  It will be printed by
+   argp_help if the ARGP_HELP_BUG_ADDR flag is set (as it is by various
+   standard help messages), embedded in a sentence that says something like
+   `Report bugs to ADDR.'.  */
+extern char *argp_program_bug_address;
 
 /* Flags for argp_help.  */
-#define ARGP_HELP_USAGE		0x01 /* Print a Usage: message. */
+#define ARGP_HELP_USAGE		0x01 /* a Usage: message. */
 #define ARGP_HELP_SHORT_USAGE	0x02 /*  " but don't actually print options. */
-#define ARGP_HELP_SEE		0x04 /* Print a `for more help...' message. */
-#define ARGP_HELP_LONG		0x08 /* Print a long help message. */
+#define ARGP_HELP_SEE		0x04 /* a `Try ... for more help' message. */
+#define ARGP_HELP_LONG		0x08 /* a long help message. */
+#define ARGP_HELP_PRE_DOC	0x10 /* doc string preceding long help.  */
+#define ARGP_HELP_POST_DOC	0x20 /* doc string following long help.  */
+#define ARGP_HELP_DOC		(ARGP_HELP_PRE_DOC | ARGP_HELP_POST_DOC)
+#define ARGP_HELP_BUG_ADDR	0x40 /* bug report address */
 
 /* These ARGP_HELP flags are only understood by argp_state_help.  */
-#define ARGP_HELP_EXIT_ERR	0x10 /* Call exit(1) instead of returning.  */
-#define ARGP_HELP_EXIT_OK	0x20 /* Call exit(0) instead of returning.  */
+#define ARGP_HELP_EXIT_ERR	0x100 /* Call exit(1) instead of returning.  */
+#define ARGP_HELP_EXIT_OK	0x200 /* Call exit(0) instead of returning.  */
 
 /* The standard thing to do after a program command line parsing error, if an
    error message has already been printed.  */
@@ -293,7 +306,8 @@
   (ARGP_HELP_SHORT_USAGE | ARGP_HELP_SEE | ARGP_HELP_EXIT_ERR)
 /* The standard thing to do in response to a --help option.  */
 #define ARGP_HELP_STD_HELP \
-  (ARGP_HELP_SHORT_USAGE | ARGP_HELP_LONG | ARGP_HELP_EXIT_OK)
+  (ARGP_HELP_SHORT_USAGE | ARGP_HELP_LONG | ARGP_HELP_EXIT_OK \
+   | ARGP_HELP_DOC | ARGP_HELP_BUG_ADDR)
 
 /* Output a usage message for ARGP to STREAM.  FLAGS are from the set
    ARGP_HELP_*.  */
diff -ru hurd-0.0/libstore/ChangeLog hurd-0.1/libstore/ChangeLog
--- hurd-0.0/libstore/ChangeLog	Mon Jul 29 12:34:35 1996
+++ hurd-0.1/libstore/ChangeLog	Thu Sep  5 10:12:36 1996
@@ -1,3 +1,56 @@
+Wed Sep  4 13:01:19 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp.c (parse_opt): --layer isn't implemented, so say so.
+
+	* storeread.c (main): Add new args to store_*_create calls.
+	* storecat.c (main): Use new interface to store_argp.
+
+Wed Sep  3 11:00:00 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp.c (struct store_parsed): New type.
+	(store_parsed_free, store_parsed_append_args, store_parsed_open):
+	New functions.
+	(parse_opt): Use new store_parsed structure instead of the old
+	store_pars_hook, and just fill in the names rather than doing the
+	open here.  Don't take a struct store_argp_params as input any
+	more; instead just take the address of a location in which to
+	return a store_parsed structure.
+	(struct store_parse_hook): Type removed.
+	(free_hook, open_file): Functions removed.
+	<assert.h>: New include.
+	<stdlib.h>, <fcntl.h>: Includes removed.
+	(options): --machdev/-m renamed to --device/-D.
+	* store.h (struct store): Make log2_* fields unsigned.
+	(STORE_NO_FILEIO): New macro.
+	(STORE_HARD_READONLY, STORE_ENFORCED): Values changed.
+	(STORE_GENERIC_FLAGS): Add STORE_NO_FILEIO.
+	(struct store_argp_params): Type removed.
+	(store_parsed_Free, store_parsed_open, store_parsed_append_args):
+	New declarations.
+	(struct store_parsed): New incomplete type.
+	
+Mon Sep  2 18:56:26 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* store.h (store_open): New declaration.
+	* open.c: New file.
+	* Makefile (SRCS): Add open.c.
+
+Wed Aug 21 14:40:15 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* device.c (store_device_open): Don't call store_device_create if
+	device_open fails.
+
+Tue Aug 20 14:37:33 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* argp.c (free_hook): Free H->params->args if necessary.
+	(parse_opt): Initialize and fill in H->params->args when appropriate.
+	<argz.h>: New include.
+
+Mon Aug 19 14:31:33 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* store.h (struct store_argp_params): Add return_args, args, &
+	args_len fields.
+
 Fri Jul 19 16:16:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* decode.c (store_std_leaf_decode): Decode name too.
diff -ru hurd-0.0/libstore/Makefile hurd-0.1/libstore/Makefile
--- hurd-0.0/libstore/Makefile	Tue May 21 20:18:16 1996
+++ hurd-0.1/libstore/Makefile	Thu Sep  5 10:12:36 1996
@@ -25,7 +25,7 @@
 libname = libstore
 SRCS = create.c derive.c make.c rdwr.c set.c device.c file.c stripe.c \
 	storeread.c storecat.c enc.c encode.c decode.c clone.c argp.c \
-	std.c kids.c null.c flags.c
+	std.c kids.c null.c flags.c open.c
 LCLHDRS=store.h
 installhdrs=store.h
 
@@ -36,3 +36,4 @@
 
 storeread: libstore.so ../libshouldbeinlibc/libshouldbeinlibc.so
 storecat: libstore.so ../libshouldbeinlibc/libshouldbeinlibc.so
+storeargs: libstore.so ../libshouldbeinlibc/libshouldbeinlibc.so
diff -ru hurd-0.0/libstore/argp.c hurd-0.1/libstore/argp.c
--- hurd-0.0/libstore/argp.c	Sun Jun 16 22:50:06 1996
+++ hurd-0.1/libstore/argp.c	Thu Sep  5 10:12:37 1996
@@ -20,86 +20,127 @@
    with this program; if not, write to the Free Software Foundation, Inc.,
    675 Mass Ave, Cambridge, MA 02139, USA. */
 
-#include <stdlib.h>
 #include <string.h>
-#include <fcntl.h>
+#include <assert.h>
 #include <hurd.h>
 #include <argp.h>
-#include <error.h>
+#include <argz.h>
 
 #include "store.h"
 
 static const struct argp_option options[] = {
-  {"machdev", 'm', 0, 0, "DEVICE is a mach device, not a file"},
-  {"interleave", 'i', "BLOCKS", 0, "Interleave in runs of length BLOCKS"},
-  {"layer",   'l', 0, 0, "Layer multiple devices for redundancy"},
+  {"device",	'D', 0,        0, "DEVICE is a mach device, not a file"},
+  {"interleave",'i', "BLOCKS", 0, "Interleave in runs of length BLOCKS"},
+  {"layer",   	'l', 0,        0, "Layer multiple devices for redundancy"},
   {0}
 };
 
 static const char args_doc[] = "DEVICE...";
-static const char doc[] = "If multiple DEVICEs are specified, they are"
+static const char doc[] = "\vIf multiple DEVICEs are specified, they are"
 " concatenated unless either --interleave or --layer is specified (mutually"
 " exlusive).";
 
-/* Used to hold data during argument parsing.  */
-struct store_parse_hook
+struct store_parsed
 {
-  /* A malloced vector of stores specified on the command line, NUM_STORES
-     long.  */
-  struct store **stores;
-  size_t num_stores;
-
-  /* Pointer to params struct passed in by user.  */
-  struct store_argp_params *params;
-
+  char *names;
+  size_t names_len;
   off_t interleave;		/* --interleave value */
   int machdev : 1;		/* --machdev specified */
   int layer : 1;		/* --layer specified */
 };
 
-/* Free the parse hook H.  If FREE_STORES is true, also free the stores in
-   H's store vector, otherwise just free the vector itself.  */
-static void
-free_hook (struct store_parse_hook *h, int free_stores)
+void
+store_parsed_free (struct store_parsed *parsed)
 {
-  int i;
-  if (free_stores)
-    for (i = 0; i < h->num_stores; i++)
-      store_free (h->stores[i]);
-  if (h->stores)
-    free (h->stores);
-  free (h);
+  free (parsed->names);
+  free (parsed);
 }
-
-static error_t
-open_file (char *name, struct store_parse_hook *h, struct store **s)
+
+/* Add the arguments  PARSED, and return the corresponding store in STORE.  */
+error_t
+store_parsed_append_args (const struct store_parsed *parsed,
+			  char **args, size_t *args_len)
 {
-  error_t err;
-  int flags = h->params->flags;
-  int open_flags = (flags & STORE_HARD_READONLY) ? O_RDONLY : O_RDWR;
-  file_t node = file_name_lookup (name, open_flags, 0);
+  error_t err = 0;
+  size_t num_names = argz_count (parsed->names, parsed->names_len);
 
-  if (node == MACH_PORT_NULL)
-    return errno;
+  if (parsed->machdev)
+    err = argz_add (args, args_len, "--machdev");
 
-  err = store_create (node, flags, 0, s);
-  if (err)
+  if (!err && num_names > 1 && (parsed->interleave || parsed->layer))
     {
-      if (! h->params->no_file_io)
-	/* Try making a store that does file io to NODE.  */
-	err = store_file_create (node, flags, s);
-      if (err)
-	mach_port_deallocate (mach_task_self (), node);
+      char buf[40];
+      if (parsed->interleave)
+	snprintf (buf, sizeof buf, "--interleave=%ld", parsed->interleave);
+      else
+	snprintf (buf, sizeof buf, "--layer=%ld", parsed->layer);
+      err = argz_add (args, args_len, buf);
     }
 
+  if (! err)
+    err = argz_append (args, args_len, parsed->names, parsed->names_len);
+
   return err;
 }
 
+/* Open PARSED, and return the corresponding store in STORE.  */
+error_t
+store_parsed_open (const struct store_parsed *parsed, int flags,
+		   struct store_class *classes,
+		   struct store **store)
+{
+  size_t num = argz_count (parsed->names, parsed->names_len);
+  error_t open (char *name, struct store **store)
+    {
+      if (parsed->machdev)
+	return store_device_open (name, flags, store);
+      else
+	return store_open (name, flags, classes, store);
+    }
+
+  if (num == 1)
+    return open (parsed->names, store);
+  else
+    {
+      int i;
+      char *name;
+      error_t err = 0;
+      struct store **stores = malloc (sizeof (struct store *) * num);
+
+      if (! stores)
+	return ENOMEM;
+
+      for (i = 0, name = parsed->names;
+	   !err && i < num;
+	   i++, name = argz_next (parsed->names, parsed->names_len, name))
+	err = open (name, &stores[i]);
+
+      if (! err)
+	if (parsed->interleave)
+	  err =
+	    store_ileave_create (stores, num, parsed->interleave,
+				 flags, store);
+	else if (parsed->layer)
+	  assert (! parsed->layer);
+	else
+	  err = store_concat_create (stores, num, flags, store);
+
+      if (err)
+	{
+	  while (i > 0)
+	    store_free (stores[i--]);
+	  free (stores);
+	}
+
+      return err;
+    }
+}
+
 static error_t
 parse_opt (int opt, char *arg, struct argp_state *state)
 {
-  error_t err = 0;
-  struct store_parse_hook *h = state->hook;
+  error_t err;
+  struct store_parsed *parsed = state->hook;
 
   /* Print a parsing error message and (if exiting is turned off) return the
      error code ERR.  */
@@ -108,100 +149,63 @@
 
   switch (opt)
     {
-      struct store *s;
-
     case 'm':
-      h->machdev = 1; break;
+      parsed->machdev = 1; break;
 
     case 'i':
-      if (h->layer)
+      if (parsed->layer)
 	PERR (EINVAL, "--layer and --interleave are exclusive");
-      if (h->interleave)
+      if (parsed->interleave)
 	/* Actually no reason why we couldn't support this.... */
 	PERR (EINVAL, "--interleave specified multiple times");
 
-      h->interleave = atoi (arg);
-      if (! h->interleave)
+      parsed->interleave = atoi (arg);
+      if (! parsed->interleave)
 	PERR (EINVAL, "%s: Bad value for --interleave", arg);
       break;
 
     case 'l':
-      if (h->interleave)
+#if 1
+      argp_failure (state, 5, 0, "--layer not implemented");
+      return EINVAL;
+#else
+      if (parsed->interleave)
 	PERR (EINVAL, "--layer and --interleave are exclusive");
-      h->layer = 1;
+      parsed->layer = 1;
+#endif
       break;
 
     case ARGP_KEY_ARG:
       /* A store device to use!  */
-      if (h->machdev)
-	err = store_device_open (arg, h->params->flags, &s);
-      else
-	err = open_file (arg, h, &s);
+      err = argz_add (&parsed->names, &parsed->names_len, arg);
       if (err)
-	{
-	  argp_failure (state, 1, err, "%s", arg);
-	  return err;
-	}
-      else
-	{
-	  struct store **stores = realloc (h->stores, h->num_stores + 1);
-	  if (stores)
-	    {
-	      stores[h->num_stores++] = s;
-	      h->stores = stores;
-	    }
-	  else
-	    return ENOMEM;	/* Just fucking lovely */
-	}
+	argp_failure (state, 1, err, "%s", arg);
+      return err;
       break;
 
     case ARGP_KEY_INIT:
       /* Initialize our parsing state.  */
       if (! state->input)
 	return EINVAL;		/* Need at least a way to return a result.  */
-      h = malloc (sizeof (struct store_parse_hook));
-      if (! h)
+      state->hook = malloc (sizeof (struct store_parsed));
+      if (! state->hook)
 	return ENOMEM;
-      bzero (h, sizeof (struct store_parse_hook));
-      h->params = state->input;
-      state->hook = h;
+      bzero (state->hook, sizeof (struct store_parsed));
       break;
 
     case ARGP_KEY_ERROR:
       /* Parsing error occured, free everything. */
-      free_hook (h, 1); break;
+      store_parsed_free (parsed); break;
 
     case ARGP_KEY_SUCCESS:
       /* Successfully finished parsing, return a result.  */
-
-      if (h->num_stores == 0)
+      if (parsed->names == 0)
 	{
-	  free_hook (h, 1);
+	  store_parsed_free (parsed);
 	  PERR (EINVAL, "No store specified");
 	}
-
-      if (state->input == 0)
-	/* No way to return a value!  */
-	err = EINVAL;
-      else if (h->num_stores == 1)
-	s = h->stores[0];	/* Just a single store.  */
-      else if (h->interleave)
-	err =
-	  store_ileave_create (h->stores, h->num_stores, h->interleave,
-			       h->params->flags, &s);
-      else if (h->layer)
-	{
-	  free_hook (h, 1);
-	  PERR (EINVAL, "--layer not implemented");
-	}
       else
-	err =
-	  store_concat_create (h->stores, h->num_stores, h->params->flags, &s);
-
-      free_hook (h, err);
-      if (! err)
-	h->params->result = s;
-
+	*(struct store_parsed **)state->input = parsed;
       break;
 
     default:
diff -ru hurd-0.0/libstore/device.c hurd-0.1/libstore/device.c
--- hurd-0.0/libstore/device.c	Tue May 21 20:12:38 1996
+++ hurd-0.1/libstore/device.c	Tue Sep  3 10:21:06 1996
@@ -117,12 +117,13 @@
     return err;
 
   err = device_open (dev_master, open_flags, (char *)name, &device);
-
   mach_port_deallocate (mach_task_self (), dev_master);
-
-  err = store_device_create (device, flags, store);
-  if (err)
-    mach_port_deallocate (mach_task_self (), device);
+  if (! err)
+    {
+      err = store_device_create (device, flags, store);
+      if (err)
+	mach_port_deallocate (mach_task_self (), device);
+    }
 
   return err;
 }
Only in hurd-0.1/libstore: open.c
diff -ru hurd-0.0/libstore/store.h hurd-0.1/libstore/store.h
--- hurd-0.0/libstore/store.h	Tue May 21 19:58:28 1996
+++ hurd-0.1/libstore/store.h	Thu Sep  5 10:12:37 1996
@@ -68,9 +68,9 @@
   size_t size;
 
   /* Log_2 (BLOCK_SIZE) or 0 if not a power of 2. */
-  int log2_block_size;
+  unsigned log2_block_size;
   /* Log_2 (VM_PAGE_SIZE / BLOCK_SIZE); only valid if LOG2_BLOCK_SIZE is.  */
-  int log2_blocks_per_page;
+  unsigned log2_blocks_per_page;
 
   /* Random flags.  */
   int flags;
@@ -91,15 +91,18 @@
    <hurd/hurd_types.h>.  XXX synchronize these values.  */
 
 /* Flags that reflect something immutable about the object.  */
-#define STORE_IMMUTABLE_FLAGS	0xFF
+#define STORE_IMMUTABLE_FLAGS	0x00FF
 
 /* Flags implemented by generic store code.  */
-#define STORE_READONLY		0x100	/* No writing allowed. */
-#define STORE_GENERIC_FLAGS	STORE_READONLY
+#define STORE_READONLY		0x0100	/* No writing allowed. */
+#define STORE_NO_FILEIO		0x0200	/* If store_create can't fetch store
+					   information, don't create a store
+					   using file io instead.  */
+#define STORE_GENERIC_FLAGS	(STORE_READONLY | STORE_NO_FILEIO)
 
 /* Flags implemented by each backend.  */
-#define STORE_HARD_READONLY	0x200	/* Can't be made writable.  */
-#define STORE_ENFORCED		0x400	/* Range is enforced by device.  */
+#define STORE_HARD_READONLY	0x0400	/* Can't be made writable.  */
+#define STORE_ENFORCED		0x0800	/* Range is enforced by device.  */
 #define STORE_BACKEND_SPEC_BASE	0x1000 /* Here up are backend-specific */
 #define STORE_BACKEND_FLAGS	(STORE_HARD_READONLY | STORE_ENFORCED \
 				 | ~(STORE_BACKEND_SPEC_BASE - 1))
@@ -169,6 +172,14 @@
 
 void store_free (struct store *store);
 
+/* Open the file NAME, and return a new store in STORE, which refers to the
+   storage underlying it.  CLASSES is used to select classes specified by the
+   provider; if it is 0, STORE_STD_CLASSES is used.  FLAGS is set with
+   store_set_flags.  A reference to the open file is created (but may be
+   destroyed with store_close_source).  */
+error_t store_open (char *name, int flags, struct store_class *classes,
+		    struct store **store);
+
 /* Allocate a new store structure with class CLASS, and the various other
    fields initialized to the given parameters.  */
 struct store *
@@ -392,22 +403,24 @@
 
 /* An argument parser that may be used for parsing a simple command line
    specification for stores.  The accompanying input parameter must be a
-   pointer to a structure of type struct store_argp_param.  */
+   pointer to a location in which to store the resulting pointer to a struct
+   store_parsed.  */
 extern struct argp store_argp;
 
-/* Structure used to pass in arguments and return the result from
-   STORE_ARGP.  */
-struct store_argp_params
-{
-  /* An initial set of flags desired to be set.  */
-  int flags;
-
-  /* If true, don't attempt use store_file_create to create a store on files
-     upon which store_create has failed.  */
-  int no_file_io : 1;
-
-  /* Parsed store returned here.  */
-  struct store *result;
-};
+/* The result of parsing a store, which should be enough information to open
+   it, or return the arguments.  */
+struct store_parsed;
+
+/* Free all resources used by PARSED.  */
+void store_parsed_free (struct store_parsed *parsed);
+
+/* Open PARSED, and return the corresponding store in STORE.  */
+error_t store_parsed_open (const struct store_parsed *parsed, int flags,
+			   struct store_class *classes,
+			   struct store **store);
+
+/* Add the arguments  PARSED, and return the corresponding store in STORE.  */
+error_t store_parsed_append_args (const struct store_parsed *parsed,
+				  char **args, size_t *args_len);
 
 #endif /* __STORE_H__ */
diff -ru hurd-0.0/libstore/storecat.c hurd-0.1/libstore/storecat.c
--- hurd-0.0/libstore/storecat.c	Tue May 21 20:49:26 1996
+++ hurd-0.1/libstore/storecat.c	Thu Sep  5 10:12:38 1996
@@ -13,10 +13,12 @@
   struct store *s;
   char buf[4096], *data = buf;
   size_t data_len = sizeof (buf);
-  struct store_argp_params params = { 0, 0, 0 };
+  struct store_parsed *parsed;
 
-  argp_parse (&store_argp, argc, argv, 0, 0, &params);
-  s = params.result;
+  argp_parse (&store_argp, argc, argv, 0, 0, &parsed);
+  err = store_parsed_open (parsed, STORE_READONLY, 0, &s);
+  if (err)
+    error (4, err, "store_parsed_open");
 
   err = store_read (s, 0, s->size, &data, &data_len);
   if (err)
